#!/bin/bash
# Запуск скрипта:  
# ./radio <mountpoint>  
# - cоздается конфиг файл (название - <mountpoint>.mpd.conf).
# - папка с конфиг-файлами (папка называется так же , как и  <mountpoint>).
# - порт автоматически указывается в конфиге. 
# - процесс автоматически добавляется в systemd
# - управление потоком ./radio.sh <название> 
# Со стороны пользователя остается лишь добавить пути к плейлистам и изменить конфиг по усмотрению(название трансляции,описание и т.д)
source ./.port
ICECAST_DIR=./
if [[ $# -lt 1 ]]; then
	echo "Формат ./radio.sh <поток>"
			exit 1
fi

if [[ ! -f ./$1.mpd.conf ]];then
       cp  -p $ICECAST_DIR/template.mpd.conf $ICECAST_DIR/$1.mpd.conf   
       mkdir $ICECAST_DIR/$1
       mkdir $ICECAST_DIR/$1/Music
       touch $ICECAST_DIR/$1/mpd.log
       touch $ICECAST_DIR/$1/mpdstate
       touch $ICECAST_DIR/$1/mpd.db
       touch $ICECAST_DIR/$1/mpd.pid
       mkdir $ICECAST_DIR/$1/playlists
       sed -i 's?#1?'`pwd`/$1'?' $ICECAST_DIR/$1.mpd.conf
       sed -i "s/#2/$PORT/g" $ICECAST_DIR/$1.mpd.conf
       sed -i "s/#3/$1/g" $ICECAST_DIR/$1.mpd.conf 
       chown  -R icecastradio $ICECAST_DIR/$1
       chgrp  -R icecastradio $ICECAST_DIR/$1
       chmod -R 777 $ICECAST_DIR/$1
       chmod +x $ICECAST_DIR/$1/playlists
       echo "Файлы конфигураций cозданы успешно !"
       
       cp template.service /etc/systemd/system/$1.service
       PATH_TO_CFG=`pwd`/$1.mpd.conf 
       sed -i 's?#1?'$PATH_TO_CFG'?' /etc/systemd/system/$1.service
       echo PORT=$((PORT+1)) > $ICECAST_DIR/.port 
       systemctl daemon-reload
       systemctl start $1 
       systemctl enable $1
       echo "Запущен mpd-поток под названием : $1 по адресу : radio.azbyka.ru:8000/$PORT"
       echo "Для начала работы требуется обновить базу данных mpd"
       echo "Для работа с потоком : ./radio <название потока>" 
else 
       ncmpc -p `cat .'/'$1.mpd.conf | grep port | awk '{ print $2 ; exit; }' | tr -d \"`
fi
  
    
